﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Data;
using System.Data.OleDb;


public partial class _Default : System.Web.UI.Page 
{
    private void Page_Load(object sender, System.EventArgs e)
    {
        if (!Page.IsPostBack) 
        {
            LoadSupervisors(String.Empty,0);
        }

    }
    private void LoadSupervisors(string filter, int iNumberretrived)
    {
        DataTable dtable = new DataTable();
        DataTable dtable1 = new DataTable();
        DataRow orow;
        int nTotal;
        nTotal = iNumberretrived + 5;
        if (Cache["MultipleCombo"] == null)
        {
            string mdbPath = Server.MapPath("~/Data/NWind.mdb");
            OleDbConnection dbCon = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + mdbPath);
            dbCon.Open();

            string sql = "SELECT * from Customers";
            if (filter != String.Empty)
            {
                sql += " WHERE CompanyName LIKE '" + filter.Replace("'", "''") + "%'";
            }

            OleDbDataAdapter adapter = new OleDbDataAdapter(sql, dbCon);
            DataTable dt = new DataTable();
            adapter.Fill(dt);
            dbCon.Close();
            Cache.Insert("MultipleCombo", dt);
        }
        if (filter != "")
        {
            DataRow[] filteredRows;
            int i;
            dtable1 = (DataTable)Cache["MultipleCombo"];
            filteredRows = dtable1.Select("CompanyName LIKE '" + filter + "%'");
            dtable.Columns.Add("CompanyName");
            dtable.Columns.Add("City");
            dtable.Columns.Add("ContactTitle");
            int iCnt;
            if (nTotal > filteredRows.Length)
            {
                nTotal = filteredRows.Length;
            }
            orow = dtable.NewRow();
            orow["CompanyName"] = "";
            orow["City"] = "";
            orow["ContactTitle"] = "";
            dtable.Rows.Add(orow);
            for (iCnt = iNumberretrived; iCnt <= nTotal - 1; iCnt++)
            {
                orow = dtable.NewRow();
                orow["CompanyName"] = filteredRows[iCnt]["CompanyName"].ToString();
                orow["City"] = filteredRows[iCnt]["City"].ToString();
                orow["ContactTitle"] = filteredRows[iCnt]["ContactTitle"].ToString();
                dtable.Rows.Add(orow);
            }
        }
        else
        {
            dtable1 = (DataTable)Cache["MultipleCombo"];
            dtable.Columns.Add("CompanyName");
            dtable.Columns.Add("City");
            dtable.Columns.Add("ContactTitle");
            int iCnt;
            orow = dtable.NewRow();
            orow["CompanyName"]= "";
            orow["City"] = "";
            orow["ContactTitle"] = "";
            dtable.Rows.Add(orow);
            for (iCnt = iNumberretrived; iCnt <= nTotal - 1; iCnt++)
            {
                orow = dtable.NewRow();
                orow["CompanyName"] = dtable1.Rows[iCnt]["CompanyName"].ToString();
                orow["City"] = dtable1.Rows[iCnt]["City"].ToString();
                orow["ContactTitle"] = dtable1.Rows[iCnt]["ContactTitle"].ToString();
                dtable.Rows.Add(orow);
            }
        }

        RadComboBox1.DataSource = dtable;
        RadComboBox1.DataBind();
    }



    protected void Button1_Click(object sender, System.EventArgs e)
    {
        
    }

    protected void RadComboBox1_ItemsRequested(object o, RadComboBoxItemsRequestedEventArgs e)
    {
         RadComboBox1.Items.Clear();
         LoadSupervisors(e.Text, e.NumberOfItems);
        
    }
    protected void RadComboBox1_ItemDataBound1(object sender, RadComboBoxItemEventArgs e)
    {
        e.Item.Text = ((DataRowView)e.Item.DataItem)["CompanyName"].ToString() + "; " + ((DataRowView)e.Item.DataItem)["City"].ToString() + "; " + ((DataRowView)e.Item.DataItem)["ContactTitle"].ToString();
        e.Item.Value = ((DataRowView)e.Item.DataItem)["CompanyName"].ToString() + "; " + ((DataRowView)e.Item.DataItem)["City"].ToString() + "; " + ((DataRowView)e.Item.DataItem)["ContactTitle"].ToString();
    }
}
